use strict;
use CGI;
use CGI::Util;
use CGI::Carp qw(fatalsToBrowser);
use Image::Size;

use constant HtmlCharset => 'EUC-JP';
use constant HtmlExpires => '-1d';

my $oCgi = new CGI;
my $sExe = $oCgi->param('EXE');
my $sObj = $oCgi->param('OBJ');

if($sExe eq 'DSP') {
	my $sUrl = $oCgi->url();
	my $raRes = getDsp($sObj);
	my $sTbl = '';
	foreach my $sRow (@$raRes) {
		$sTbl .= 
		sprintf(
		qq{<TR><TD><A HREF="%s?EXE=IMG&OBJ=%s" TARGET="DSP">%s</A></TD><TD>%s</TD></TR>},
			$sUrl, CGI::Util::escape($sRow->[0]), $oCgi->escapeHTML($sRow->[0]), $sRow->[1]);
    }
    print $oCgi->header(-type =>'text/html',
						  -expires=>HtmlExpires,
            			  -charset =>HtmlCharset);
	print<<EOF;
<HTML><BODY><H1>:$sObj</H1>
<TABLE BORDER="1">
<TR><TH>ȥ</TH><TH>Ͽ</TH></TR>
$sTbl
</TABLE>
</BODY></HTML>
EOF

}
elsif($sExe eq 'IMG') {
	my $sImg = getImg($sObj);
    my %hType = (
    	'JPG' => 'image/jpeg',
        'PNG' => 'image/png',
        'GIF' => 'image/gif',);
	my $sType = $hType{(imgsize(\$sImg))[2]};
    $sType ||= 'image/jpeg';  #tekitou

    print $oCgi->header(-type => $sType, -expires=>HtmlExpires,);
    print $sImg;
}
elsif($sExe eq 'INS') {
	binmode($oCgi->upload('FILIMG'));
	my ($sWk, $sImg);
	$sImg = '';
	while(read($oCgi->upload('FILIMG'), $sWk, 4096)) {
		$sImg .= $sWk;
	}
        my $iLen = length($sImg);
	my $sRes = insData( $oCgi->param('TXTTTL'),
						$oCgi->param('TXTENT'),
					    $sImg);
    print $oCgi->header(-type =>'text/html',
						  -expires=>HtmlExpires,
            			  -charset =>HtmlCharset);
	print<<EOF;
<HTML><BODY><H1>Ͽ</H1>
:$sRes<BR>
: $iLen
</BODY></HTML>
EOF

}
else {
	my $sUrl = $oCgi->url();
	my $sRel = $oCgi->url(-relative=>1);
    print $oCgi->header(-type =>'text/html',
						  -expires=>HtmlExpires,
            			  -charset =>HtmlCharset);
	print<<EOF;
<HTML>
<HEAD><TITLE>TEST($sRel)</TITLE></HEAD>
<BODY><H1>ƥ($sRel)</H1>
<FORM METHOD="POST" ACTION="$sUrl">
<INPUT TYPE="HIDDEN" NAME="EXE" VALUE="DSP">
<TABLE>
<TR><TD>оݡ</TD><TD><INPUT TYPE="TEXT" NAME="OBJ"></TD></TR>
</TABLE>
<INPUT TYPE="SUBMIT" VALUE="">
</FORM>
<FORM METHOD="POST" ENCTYPE="multipart/form-data" ACTION="$sUrl">
<INPUT TYPE="HIDDEN" NAME="EXE" VALUE="INS">
<TABLE>
<TR><TD>ȥ롧</TD><TD><INPUT TYPE="TEXT" NAME="TXTTTL"></TD></TR>
<TR><TD>Ͽա</TD><TD><INPUT TYPE="TEXT" NAME="TXTENT"></TD></TR>
<TR><TD>ե롧</TD><TD><INPUT TYPE="FILE" NAME="FILIMG"></TD></TR>
</TABLE>
<INPUT TYPE="SUBMIT" VALUE="Ͽ">
</FORM>
</BODY></HTML>
EOF
}

