#!/usr/bin/perl
use strict;
use DBI;
my @aConn = ('dbi:Pg:host=lins;dbname=test', 'scott', 'tiger',);
sub getDsp($) {
    my ($sParam) = @_;
    my $hDb = DBI->connect(@aConn, 
        {RaiseError=>1, AutoCommit=>0}) or
            die "CONNECT ERROR $DBI::errstr";       
    my $hSt = $hDb->prepare( 
        q{SELECT TITLE,TO_CHAR(CREDT,'YYYY/MM/DD') 
          FROM ALBUM WHERE TITLE LIKE ?} );
    $hSt->execute($sParam);
    my @aRes;
    while( my @aWk = $hSt->fetchrow_array()) {
        push @aRes, \@aWk;
    };
    $hSt->finish();
    $hDb->disconnect();
    return \@aRes;
}
sub insData($$$) {
    my ($sTitle, $sDate, $sPict) = @_;
    my $hDb = DBI->connect(@aConn,
        {RaiseError=>1, AutoCommit=>0}) or
            die "CONNECT ERROR $DBI::errstr";
    eval {
        my $hSt = $hDb->prepare(
            q/INSERT INTO ALBUM (TITLE, CREDT, PICIMG) VALUES (?, ?, ?)/);
        $hSt->bind_param(3, undef, DBI::SQL_BINARY);
        $hSt->execute($sTitle, $sDate, $sPict);
    };
    my $sRes;
    if($@) {
        $hDb->rollback;
        $sRes = "NG: $@";
    }
    else {
        $hDb->commit;
        $sRes = 'OK:';
    }
    $hDb->disconnect();
    return $sRes;
}
sub getImg($) {
    my ($sParam) = @_;
    my $hDb = DBI->connect(@aConn, 
        {RaiseError=>1, AutoCommit=>0}) or
            die "CONNECT ERROR $DBI::errstr";       
    $hDb->{LongReadLen}=2_000_000;
    $hDb->{LongTruncOk}=1;

    my $hSt = $hDb->prepare( 
        q/SELECT PICIMG FROM ALBUM WHERE TITLE = ?/ );
    $hSt->execute($sParam);
    my ($sRes) = $hSt->fetchrow_array();
    $hSt->finish();
    $hDb->disconnect();
    return $sRes;
}
require './cgitmpl.pl';
